Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncTop.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncTop.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -43,4 +43,5 @@
 #include "TLibCommon/TComPrediction.h"
 #include "TLibCommon/TComTrQuant.h"
+#include "TLibCommon/TComLoopFilter.h"
 #include "TLibCommon/AccessUnit.h"
 
@@ -76,6 +77,6 @@
   UInt                    m_uiNumAllPicCoded;             ///< number of coded pictures
   TComList<TComPic*>      m_cListPic;                     ///< dynamic list of pictures
-  
-#if H_MV
+
+#if NH_MV
   TComPicLists*           m_ivPicLists;                   ///< access to picture lists of other layers 
 #endif
@@ -87,5 +88,5 @@
   TEncSearch              m_cSearch;                      ///< encoder search class
   //TEncEntropy*            m_pcEntropyCoder;                     ///< entropy encoder
-  TEncCavlc*              m_pcCavlcCoder;                       ///< CAVLC encoder  
+  TEncCavlc*              m_pcCavlcCoder;                       ///< CAVLC encoder
   // coding tool
   TComTrQuant             m_cTrQuant;                     ///< transform & quantization class
@@ -96,7 +97,5 @@
   TEncSbac                m_cSbacCoder;                   ///< SBAC encoder
   TEncBinCABAC            m_cBinCoderCABAC;               ///< bin coder CABAC
-  TEncSbac*               m_pcSbacCoders;                 ///< SBAC encoders (to encode substreams )
-  TEncBinCABAC*           m_pcBinCoderCABACs;             ///< bin coders CABAC (one per substream)
-  
+
   // processing unit
   TEncGOP                 m_cGOPEncoder;                  ///< GOP encoder
@@ -104,8 +103,7 @@
   TEncCu                  m_cCuEncoder;                   ///< CU encoder
   // SPS
-  TComSPS                 m_cSPS;                         ///< SPS
-  TComPPS                 m_cPPS;                         ///< PPS
+  TComSPS                 m_cSPS;                         ///< SPS. This is the base value. This is copied to TComPicSym
+  TComPPS                 m_cPPS;                         ///< PPS. This is the base value. This is copied to TComPicSym
   // RD cost computation
-  TComBitCounter          m_cBitCounter;                  ///< bit counter for RD optimization
   TComRdCost              m_cRdCost;                      ///< RD cost computation class
   TEncSbac***             m_pppcRDSbacCoder;              ///< temporal storage for RD computation
@@ -118,16 +116,8 @@
   TEncBinCABAC            m_cRDGoOnBinCoderCABAC;         ///< going on bin coder CABAC for RD stage
 #endif
-  Int                     m_iNumSubstreams;                ///< # of top-level elements allocated.
-  TComBitCounter*         m_pcBitCounters;                 ///< bit counters for RD optimization per substream
-  TComRdCost*             m_pcRdCosts;                     ///< RD cost computation class per substream
-  TEncSbac****            m_ppppcRDSbacCoders;             ///< temporal storage for RD computation per substream
-  TEncSbac*               m_pcRDGoOnSbacCoders;            ///< going on SBAC model for RD stage per substream
-  TEncBinCABAC****        m_ppppcBinCodersCABAC;           ///< temporal CABAC state storage for RD computation per substream
-  TEncBinCABAC*           m_pcRDGoOnBinCodersCABAC;        ///< going on bin coder CABAC for RD stage per substream
 
   // quality control
   TEncPreanalyzer         m_cPreanalyzer;                 ///< image characteristics analyzer for TM5-step3-like adaptive QP
 
-  TComScalingList         m_scalingList;                 ///< quantization matrix information
   TEncRateCtrl            m_cRateCtrl;                    ///< Rate control class
 
@@ -136,64 +126,26 @@
   TAppComCamPara*         m_cCamParam;
 #endif
-  
-#if H_MV
+#if NH_MV
   TEncAnalyze             m_cAnalyzeAll;
   TEncAnalyze             m_cAnalyzeI;
   TEncAnalyze             m_cAnalyzeP;
-  TEncAnalyze             m_cAnalyzeB;  
+  TEncAnalyze             m_cAnalyzeB;
+  TEncAnalyze             m_cAnalyzeAll_in;
 #endif
 protected:
   Void  xGetNewPicBuffer  ( TComPic*& rpcPic );           ///< get picture buffer which will be processed
+  Void  xInitVPS          ();                             ///< initialize VPS from encoder options
   Void  xInitSPS          ();                             ///< initialize SPS from encoder options
   Void  xInitPPS          ();                             ///< initialize PPS from encoder options
-  
+  Void  xInitScalingLists();                              ///< initialize scaling lists
+  Void  xInitHrdParameters();                             ///< initialize HRD parameters
+
   Void  xInitPPSforTiles  ();
   Void  xInitRPS          (Bool isFieldCoding);           ///< initialize PPS from encoder options
-#if H_MV
-
-  template <class T>     Void  xDelete( Bool ar, T inArray ) 
-  {
-    if( inArray != NULL)
-    {
-      if ( ar )
-      {      
-        delete[] inArray; 
-      }
-      else
-      {
-        delete inArray;
-      }
-    }
-  }
-
-  template <class T>     Void  xDelete( Bool ar, T inArray, Int idx1 ) 
-  {
-    if( inArray != NULL)
-    {
-        xDelete( ar, inArray[idx1]); 
-    }
-  }
-
-  template <class T>     Void  xDelete( Bool ar, T inArray, Int idx1, Int idx2 ) 
-  {
-    if( inArray != NULL )
-    {
-      xDelete( ar, inArray[idx1], idx2 ); 
-    }
-  }
-
-  template <class T>     Void  xDelete( Bool ar, T inArray, Int idx1, Int idx2, Int idx3 ) 
-  {
-    if( inArray != NULL )
-    {
-      xDelete( ar, inArray[idx1], idx2, idx3 ); 
-    }
-  }
-
-#endif
+
 public:
   TEncTop();
   virtual ~TEncTop();
-  
+
   Void      create          ();
   Void      destroy         ();
@@ -203,6 +155,5 @@
   Void      init            (Bool isFieldCoding);
 #endif
-
-#if H_MV  
+#if NH_MV  
   TComPicLists* getIvPicLists() { return m_ivPicLists; }
 #endif
@@ -212,8 +163,5 @@
 #endif
   Void      deletePicBuffer ();
-
-  Void      createWPPCoders(Int iNumSubstreams);
-  
-#if H_MV
+#if NH_MV
   Void      initNewPic(TComPicYuv* pcPicYuvOrg);
 #endif
@@ -221,8 +169,8 @@
   // member access functions
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   TComList<TComPic*>*     getListPic            () { return  &m_cListPic;             }
   TEncSearch*             getPredSearch         () { return  &m_cSearch;              }
-  
+
   TComTrQuant*            getTrQuant            () { return  &m_cTrQuant;             }
   TComLoopFilter*         getLoopFilter         () { return  &m_cLoopFilter;          }
@@ -235,15 +183,8 @@
   TEncSbac*               getSbacCoder          () { return  &m_cSbacCoder;           }
   TEncBinCABAC*           getBinCABAC           () { return  &m_cBinCoderCABAC;       }
-  TEncSbac*               getSbacCoders     () { return  m_pcSbacCoders;      }
-  TEncBinCABAC*           getBinCABACs          () { return  m_pcBinCoderCABACs;      }
-  
-  TComBitCounter*         getBitCounter         () { return  &m_cBitCounter;          }
+
   TComRdCost*             getRdCost             () { return  &m_cRdCost;              }
   TEncSbac***             getRDSbacCoder        () { return  m_pppcRDSbacCoder;       }
   TEncSbac*               getRDGoOnSbacCoder    () { return  &m_cRDGoOnSbacCoder;     }
-  TComBitCounter*         getBitCounters        () { return  m_pcBitCounters;         }
-  TComRdCost*             getRdCosts            () { return  m_pcRdCosts;             }
-  TEncSbac****            getRDSbacCoders       () { return  m_ppppcRDSbacCoders;     }
-  TEncSbac*               getRDGoOnSbacCoders   () { return  m_pcRDGoOnSbacCoders;   }
   TEncRateCtrl*           getRateCtrl           () { return &m_cRateCtrl;             }
 #if KWU_RC_MADPRED_E0227
@@ -252,23 +193,17 @@
   Void                    setCamParam(TAppComCamPara * pCamparam)                 { m_cCamParam = pCamparam;}
 #endif
-  TComSPS*                getSPS                () { return  &m_cSPS;                 }
-  TComPPS*                getPPS                () { return  &m_cPPS;                 }
   Void selectReferencePictureSet(TComSlice* slice, Int POCCurr, Int GOPid );
-  Int getReferencePictureSetIdxForSOP(TComSlice* slice, Int POCCurr, Int GOPid );
-  TComScalingList*        getScalingList        () { return  &m_scalingList;         }
-#if H_MV
+  Int getReferencePictureSetIdxForSOP(Int POCCurr, Int GOPid );
+#if NH_MV
   TEncAnalyze*            getAnalyzeAll         () { return &m_cAnalyzeAll; }
   TEncAnalyze*            getAnalyzeI           () { return &m_cAnalyzeI;   }
   TEncAnalyze*            getAnalyzeP           () { return &m_cAnalyzeP;   }
   TEncAnalyze*            getAnalyzeB           () { return &m_cAnalyzeB;   }
-
-  Int                     getNumAllPicCoded     () { return m_uiNumAllPicCoded; }
- 
-  Int                     getFrameId            (Int iGOPid);
-  
+  Int                     getNumAllPicCoded     () { return m_uiNumAllPicCoded; } 
+  Int                     getFrameId            (Int iGOPid);  
   TComPic*                getPic                ( Int poc );
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
 #endif
-#if H_3D
+#if NH_3D
   Void                    setSps3dExtension     ( TComSps3dExtension sps3dExtension ) { m_cSPS.setSps3dExtension( sps3dExtension );  };
 #endif
@@ -282,28 +217,33 @@
 
   /// encode several number of pictures until end-of-sequence
-#if H_MV
-  Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded  , Int gopId  );  
-
-   /// encode several number of pictures until end-of-sequence
-  Void encode( bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
-              std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, bool isTff  , Int gopId );
-
+#if NH_MV
+  Void encode( Bool bEos,
+    TComPicYuv* pcPicYuvOrg,
+    TComPicYuv* pcPicYuvTrueOrg, const InputColourSpaceConversion snrCSC, // used for SNR calculations. Picture in original colour space.
+    TComList<TComPicYuv*>& rcListPicYuvRecOut,
+    std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, Int gopId );
+
+  /// encode several number of pictures until end-of-sequence
+  Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg,
+    TComPicYuv* pcPicYuvTrueOrg, const InputColourSpaceConversion snrCSC, // used for SNR calculations. Picture in original colour space.
+    TComList<TComPicYuv*>& rcListPicYuvRecOut,
+    std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, Bool isTff, Int gopId);
 #else
-  Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
-              std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded ); 
-   /// encode several number of pictures until end-of-sequence
-  Void encode( bool bEos, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut,
-              std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, bool isTff);
-
-#endif
-
-#if H_MV
-  Void printSummary      ( Int numAllPicCoded, bool isField ); 
-#else
-  Void printSummary(bool isField) { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded, isField); }
-#endif
-
-#if H_3D
-   Void setupRenModel( Int iPoc, Int iEncViewIdx, Int iEncContent, Int iHorOffset );
+  Void encode( Bool bEos,
+               TComPicYuv* pcPicYuvOrg,
+               TComPicYuv* pcPicYuvTrueOrg, const InputColourSpaceConversion snrCSC, // used for SNR calculations. Picture in original colour space.
+               TComList<TComPicYuv*>& rcListPicYuvRecOut,
+               std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded );
+
+  /// encode several number of pictures until end-of-sequence
+  Void encode( Bool bEos, TComPicYuv* pcPicYuvOrg,
+               TComPicYuv* pcPicYuvTrueOrg, const InputColourSpaceConversion snrCSC, // used for SNR calculations. Picture in original colour space.
+               TComList<TComPicYuv*>& rcListPicYuvRecOut,
+               std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, Bool isTff);
+#endif
+  Void printSummary(Bool isField) { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded, isField, m_printMSEBasedSequencePSNR, m_printSequenceMSE, m_cSPS.getBitDepths()); }
+
+#if NH_3D_VSO
+   Void setupRenModel( Int iPoc, Int iEncViewIdx, Int iEncContent, Int iHorOffset, Int maxCuHeight ); 
 #endif
 };
@@ -312,2 +252,3 @@
 
 #endif // __TENCTOP__
+
